/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: clntmssg.m,v 1.7 92/06/11 17:19:11 rws Exp $
 */
>>TITLE ClientMessage CH08
>>ASSERTION Good A
There are no assertions in sections 8.1-8.4 for xname events.
Delivery of xname events is covered by the first test for 
.F XSendEvent .
>>STRATEGY
Put out a message explaining that there are no specific assertions for
xname events in sections 8.1-8.4, and that delivery of xname events is
covered by the first test for XSendEvent.
>>CODE

	report("There are no specific assertions for %s events in sections 8.1-8.4.", TestName);
	report("Delivery of %s events is covered by the first test for XSendEvent.", TestName);
	tet_result(TET_NOTINUSE);

>>#NOTEm >>ASSERTION
>>#NOTEm When the
>>#NOTEm .M format
>>#NOTEm field of ARTICLE xname event is not one of 8, 16, or 32,
>>#NOTEm then a
>>#NOTEm .S BadValue
>>#NOTEm error occurs.
>>#NOTEd >>ASSERTION
>>#NOTEd >>#NOTE
>>#NOTEd >>#NOTE Untestable?
>>#NOTEd >>#NOTE
>>#NOTEd The server generates xname events only when a client calls
>>#NOTEd .F XSendEvent .
>>#NOTEs >>ASSERTION
>>#NOTEs When ARTICLE xname event is delivered,
>>#NOTEs then
>>#NOTEs .M type
>>#NOTEs is set to
>>#NOTEs xname.
>>#NOTEs >>ASSERTION
>>#NOTEs >>#NOTE The method of expansion is not clear.
>>#NOTEs When ARTICLE xname event is delivered,
>>#NOTEs then
>>#NOTEs .M serial
>>#NOTEs is set
>>#NOTEs from the serial number reported in the protocol
>>#NOTEs but expanded from the 16-bit least-significant bits
>>#NOTEs to a full 32-bit value.
>>#NOTEm >>ASSERTION
>>#NOTEm When ARTICLE xname event is delivered
>>#NOTEm and the event came from a
>>#NOTEm .S SendEvent
>>#NOTEm protocol request,
>>#NOTEm then
>>#NOTEm .M send_event
>>#NOTEm is set to
>>#NOTEm .S True .
>>#NOTEs >>ASSERTION
>>#NOTEs When ARTICLE xname event is delivered
>>#NOTEs and the event was not generated by a
>>#NOTEs .S SendEvent
>>#NOTEs protocol request,
>>#NOTEs then
>>#NOTEs .M send_event
>>#NOTEs is set to
>>#NOTEs .S False .
>>#NOTEm >>ASSERTION
>>#NOTEm >>#NOTE
>>#NOTEm >>#NOTE Looks like a pretty easy test (sizeof(...)).
>>#NOTEm >>#NOTE
>>#NOTEm The size of the
>>#NOTEm .M b
>>#NOTEm member of the
>>#NOTEm .M data
>>#NOTEm union is 20 bytes.
>>#NOTEm >>ASSERTION
>>#NOTEm >>#NOTE
>>#NOTEm >>#NOTE Looks like a pretty easy test (sizeof(...)).
>>#NOTEm >>#NOTE
>>#NOTEm The size of the
>>#NOTEm .M s
>>#NOTEm member of the
>>#NOTEm .M data
>>#NOTEm union is 20 bytes.
>>#NOTEm >>ASSERTION
>>#NOTEm >>#NOTE
>>#NOTEm >>#NOTE Looks like a pretty easy test (sizeof(...)).
>>#NOTEm >>#NOTE
>>#NOTEm The size of the
>>#NOTEm .M l
>>#NOTEm member of the
>>#NOTEm .M data
>>#NOTEm union is 20 bytes.
